unit principal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, jpeg, Grids, DBGrids, WideStrings, DBXInterbase,
  FMTBcd, Provider, DB, DBClient, SqlExpr, Mask, DBCtrls, ComCtrls, Menus,
  RpCon, RpConDS, RpBase, RpSystem, RpDefine, RpRave;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    Image1: TImage;
    Label7: TLabel;
    Button2: TButton;
    DBGrid1: TDBGrid;
    Image2: TImage;
    DBEdit1: TDBEdit;
    DBEdit3: TDBEdit;
    DBText1: TDBText;
    DBText2: TDBText;
    Btn_novo: TButton;
    Btn_Cancel: TButton;
    Btn_Close: TButton;
    StatusBar1: TStatusBar;
    PopupMenu1: TPopupMenu;
    Relatorios1: TMenuItem;
    Sair1: TMenuItem;
    Sair2: TMenuItem;
    Button3: TButton;
    Image3: TImage;
    DateTimePicker1: TDateTimePicker;
    DateTimePicker2: TDateTimePicker;
    Label2: TLabel;
    Label8: TLabel;
    DBText3: TDBText;
    procedure Button1Click(Sender: TObject);
    procedure DBEdit3KeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure Btn_CloseClick(Sender: TObject);
    procedure Btn_novoClick(Sender: TObject);
    procedure Btn_CancelClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Sair1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses U_clientes, UDM;

{$R *.dfm}

function DifDias(DataVenc:TDateTime; DataAtual:TDateTime): String;
Var Data: TDateTime;
dia, mes, ano: Word;
begin
Data := DataVenc - DataAtual ;
DecodeDate( Data, ano, mes, dia);
Result := FloatToStr(Data);
end;


function gerar(emprestado:Currency;dias:Integer;juros:Real):Currency;
var
juro:Currency;
begin
 juro := emprestado *  juros /100;
 Result:= juro / 30 * dias;
end;


procedure TForm1.Btn_CancelClick(Sender: TObject);
begin
if DM.CDS_ENTRADA.State in [dsEdit,dsInsert] then
begin
if Application.MessageBox('Deseja realmente cancelar este registro?','Cancelar Registro',Mb_yesno + MB_ICONQUESTION)= mryes then
begin
Btn_Cancel.Enabled := false;
Btn_novo.Enabled := true;
DM.CDS_ENTRADA.cancel;
DM.CDS_ENTRADA.close;
end;
end;
end;

procedure TForm1.Btn_CloseClick(Sender: TObject);
begin
Close;
end;

procedure TForm1.Btn_novoClick(Sender: TObject);
begin
if Application.MessageBox('Deseja realmente Inserir um novo registro?','Inserir Registro',Mb_yesno + MB_ICONQUESTION)= mryes then
begin
Btn_Cancel.Enabled := true;
Btn_novo.Enabled := false;
DM.CDS_ENTRADA.Open;
DM.CDS_ENTRADA.Append;
DBEdit1.SetFocus;
end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
if DateTimePicker2.Date > DateTimePicker1.Date then
begin
if DM.CDS_ENTRADA.State in [dsEdit,dsInsert] then
begin
DM.CDS_ENTRADADIAS.AsInteger := strtoint(DifDias(DateTimePicker2.Date,DateTimePicker1.Date));
DM.CDS_ENTRADATOTAL_JUROS.AsCurrency := gerar(DM.CDS_ENTRADAVALOR.AsCurrency,DM.CDS_ENTRADADIAS.AsInteger,DM.CDS_ENTRADAJUROS.AsFloat);
DM.CDS_ENTRADATOTAL.AsCurrency := DM.CDS_ENTRADAVALOR.AsCurrency - DM.CDS_ENTRADATOTAL_JUROS.AsCurrency;
end;
end else
Application.MessageBox('A data inicial no pode ser maior que a data final','erro',MB_ICONERROR);
DateTimePicker2.SetFocus;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
if DM.CDS_ENTRADA.State in [dsEdit,dsInsert] then
begin
F_clientes.ShowModal;
end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
DM.CDS_ENTRADA.Open;
end;

procedure TForm1.DBEdit3KeyPress(Sender: TObject; var Key: Char);
begin
 if key = #13 then
 Button1.SetFocus;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
Btn_novo.setfocus;
end;

procedure TForm1.Sair1Click(Sender: TObject);
begin
DM.RV_RELATORIOS.ExecuteReport('RLT_GERAL');
end;

end.
